
callW                   macro   x
                        extrn   x:PROC
                        call    x
                        endm

                        p386
                        model   flat
                        locals  __
                        jumps

                        .data

buffer:                 mov     eax, ebx        ; method #1
                        mov     ecx, edx
                        nop
                        cmp     esi, edi        ; method #2
                        sbb     esi, edi
                        nop
                        or      eax, eax        ; method #3
                        test    ebx, ebx
                        xor     ecx, ecx
                        sub     edx, edx
                        nop
buffer_end:

randseed                dd      ?
tbl                     db      2048 dup (?)

                        .code
start:
                        callW   GetTickCount    ; initialize randomer
                        mov     randseed, eax

                        push    offset tbl      ; initialize disassembler
                        call    disasm_init

                        lea     esi, buffer

                        int 3

__cycle:                mov     ecx, [esi]      ; pervert current opcode
                        call    pervert_opcode
                        mov     [esi], ecx

                        push    esi             ; get opcode length (in EAX)
                        push    offset tbl
                        call    disasm_main

                        cmp     eax, -1         ; cant disasm?
                        je      __exitcycle

                        add     esi, eax        ; go to next opcode
                        cmp     esi, offset buffer_end
                        jb      __cycle
__exitcycle:

                        push    -1
                        callW   ExitProcess

include                 rnd.inc
include                 pervert.inc
include                 lde32bin.inc

                        end     start
